Node = Struct.new(:value,:next,:prev)

#Clase Lista doblemente enlazada
class Lista
    
    include Enumerable
    
    attr_reader :inicio,:final
    
    # Funcion para inicializar la lista vacia 
    def initialize()
        @inicio=nil
        @final=nil
        
    end 
    # Funcion para comprobar si la lista esta vacia
    def empty
        if (@inicio==nil)
            return true
        else
            return false
        end
    end 
    # Funcion para insertar un valor al inicio de la lista
    def insertar_uno_inicio(value)
        aux = Node.new(value,@inicio, nil)
        @inicio=aux
        if (empty)
            @fin = aux
        end

        return @inicio.value
       
    end
    # Funcion para insertar un valor al final de la lista
    def insertar_uno_final(value)
        
        aux = Node.new(value,nil,@final)
        @final = aux
        if (empty)
            @inicio=aux
        end
        
        return @final.value
    end
    # Funcion para insertar varios valores al principio de la lista 
    def insertar_varios(vector)
        aux = 0
        for i in vector
            insertar_uno_inicio(i)
            aux = aux + 1
        end
        return aux
    end
    # Funcion para extraer por el inicio un elemento de la lista
    def extraer_inicio
        if (empty)
            return false
        else
            aux = @inicio
            @inicio=@inicio.next
            # @inicio.prev=nil
            return aux.value      
        end
    end
    # Funcion para extraer por el final un elemento de la lista
    def extraer_final
        if (empty)
            return false
        else
            aux = @final
            @final=@final.prev
            # @final.next = nil
            return aux.value      
        end
    end
    # Funcion sin la cual no funcionaria el Enumerable
    def each
    	nodo = @inicio
    	while(nodo != nil)
    		yield nodo.value
    		nodo = nodo.next
    	end
    end 
end